Leetcode面试经典150题-260.只出现一次的数字III

解法都在代码里,不懂就留言或者私信

这个题算是只出现一次的数字系列比较难的题,建议先看看我写的这个系列的1、2题

Leetcode面试经典150题-136.只出现一次的数字-CSDN博客

Leetcode面试经典150题-137.只出现一次的数字II-CSDN博客

java 复制代码
class Solution {
    /**本题属于只出现一次的数字系列题比较难的一个,因为涉及两个数字
    我们知道其他的数都出现两次,所以其他的数异或之后是0,又因为0和任何数异或的结果都是这个数
    所以所有数异或的结果就是我们要求的两个数的异或的结果,我们假设两个数是a,b
    那所有数异或的结果是a^b=x, x会等于0吗? 假设等于0,说明a、b相等了,违反了题意
    所以x不会为0,那x必然某一位是1,我们取最低的为1的位,这个死记硬背就行,x & (-x)
    然后a、b这一位必然不同,不然这一位就不是1,那就是1个0,1个1
    我们按照这一位是0还是1把整个数组划分为两个子数组,分别求子数组的异或得到的就是这两个数*/
    public int[] singleNumber(int[] nums) {
        /**就两个数,又肯定存在两个不一样的数,那直接返回就是答案 */
        if(nums.length == 2) {
            return nums;
        }
        /**大于两个数的情况,我们先求整体的异或 */
        int xorAll = 0;
        for(int num : nums) {
            xorAll ^= num;
        }
        /**去除xorAll最低位的1,结果只有这一位1,其他位都是0,这一位理论上应该判断是否越界,但是根据题目的数据范围不会越界
        所以我这里不判断了,如果判断的话可以写成int lowestOne = xorAll == Integer.MIN_VALUE? 1 : xorAll &(-xorAll)*/
        int lowestOne = xorAll &(-xorAll);
        /**按照最低位的1进行分流,nums1代表按这一位是0进行分组,nums2代表按这一位是1进行分组 */
        int num1 = 0;
        int num2 = 0;
        for(int num : nums) {
            if((num & lowestOne) == 0) {
                num1 ^= num;
            } else {
                num2 ^= num;
            }
        }
        return new int[]{num1, num2};
    }
}
相关推荐
zyl7658 小时前
FlashAttention 详解:从 GPU 硬件、普通 Attention 到分块计算与 Online Softmax
算法
爱读书的小胖11 小时前
LeetCode 122:买卖股票的最佳时机 II(C)解题分析
算法
结局无敌11 小时前
React Native for OpenHarmony 实战:三方库 react-native-modal-dialog 的鸿蒙化适配指南
深度学习·算法·react native·react.js·harmonyos
OPEN-F12 小时前
ROS2系列教程:上位机建图与导航(原理综合)
算法·机器人
weixin_3077791312 小时前
C++代码实现MATLAB中的fitrtree函数功能
开发语言·c++·算法·matlab
tomwang032212 小时前
路径优化建模、优化算法分类及工程化小结
算法·数学建模·分类
小羊没烦恼!12 小时前
Ajax与JSON的一些总结
android·java·前端·数据库·mysql·算法·okhttp
by2099912 小时前
哈希表——快速找到数据:冲突、删除与扩容的实现
数据结构·c++·哈希算法·散列表
2501_9269783313 小时前
人机通信协议--人和机器之间的交互想象
人工智能·经验分享·算法·ai写作
行者全栈架构师13 小时前
【鸿蒙心迹】互动卡片全链路——把核心功能放到桌面(FormKit 实战)(HarmonyOS 7.x)
前端·算法·架构